> ## Documentation Index
> Fetch the complete documentation index at: https://docs.prequel.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Query datalake

> Execute a query against a datalake.



## OpenAPI

````yaml /generated/openapi-import-generated-2023-12-01.json post /import/datalakes/{id}/query
openapi: 3.1.0
info:
  title: Prequel Data Import
  description: Data Import API spec
  version: '2023-12-01'
servers:
  - url: https://api.prequel.co
    description: Cloud-hosted server (US)
  - url: https://eu-api.prequel.co
    description: Cloud-hosted server (EU)
  - url: https://{custom_host}
    description: Self-hosted Prequel API host
security:
  - ApiKeyAuth: []
paths:
  /import/datalakes/{id}/query:
    post:
      tags:
        - Datalakes
      summary: Query datalake
      description: Execute a query against a datalake.
      operationId: query-datalake
      parameters:
        - name: id
          in: path
          required: true
          description: Import Datalake ID.
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/DatalakeQueryRequest'
              $schema: https://json-schema.org/draft/2020-12/schema
              $id: >-
                https://github.com/prequel-co/datafeed/internal/import/api/models/datalake-query-request
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                properties:
                  status:
                    type: string
                    const: success
                  data:
                    $ref: '#/components/schemas/DatalakeQueryResponse'
                    $schema: https://json-schema.org/draft/2020-12/schema
                    $id: >-
                      https://github.com/prequel-co/datafeed/internal/import/api/models/datalake-query-response
                  message:
                    type: string
                type: object
                required:
                  - status
                  - data
                  - message
        '400':
          $ref: '#/components/responses/BadRequest'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '404':
          $ref: '#/components/responses/NotFound'
        '500':
          $ref: '#/components/responses/InternalServerError'
      security:
        - ApiKeyAuth: []
components:
  schemas:
    DatalakeQueryRequest:
      properties:
        dataset_ids:
          items:
            type: string
          type: array
        query:
          type: string
      additionalProperties: false
      type: object
      required:
        - dataset_ids
        - query
    DatalakeQueryResponse:
      properties:
        schema:
          items:
            $ref: '#/components/schemas/QueryResultSchemaField'
          type: array
        records:
          items: true
          type: array
      additionalProperties: false
      type: object
      required:
        - schema
        - records
    QueryResultSchemaField:
      properties:
        name:
          type: string
        database_type_name:
          type: string
        length:
          type: integer
        precision:
          type: integer
        scale:
          type: integer
        nullable:
          type: boolean
      additionalProperties: false
      type: object
      required:
        - name
    ErrorResponse:
      properties:
        status:
          type: string
          const: error
        message:
          type: string
        data:
          type: 'null'
      type: object
      required:
        - status
        - message
  responses:
    BadRequest:
      description: Bad Request
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
    Unauthorized:
      description: Unauthorized
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
    NotFound:
      description: Not Found
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
    InternalServerError:
      description: Internal Server Error
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: X-API-KEY

````